org.eclipse.jdt.ui.actions

## Class AddUnimplementedConstructorsAction

- java.lang.Object
- - org.eclipse.core.commands.common.EventManager
  - - org.eclipse.jface.action.AbstractAction
    - - org.eclipse.jface.action.Action
      - - org.eclipse.jdt.ui.actions.SelectionDispatchAction
        - - org.eclipse.jdt.ui.actions.AddUnimplementedConstructorsAction

All Implemented Interfaces:
  IAction, ISelectionChangedListener

    public class AddUnimplementedConstructorsAction
    extends SelectionDispatchAction

Creates unimplemented constructors for a type.

Will open the parent compilation unit in a Java editor. Opens a dialog with a list of constructors from the super class which can be generated. User is able to check or uncheck items before constructors are generated. The result is unsaved, so the user can decide if the changes are acceptable.

The action is applicable to structured selections containing elements of type `IType`.

This class may be instantiated; it is not intended to be subclassed.

Since:
  2.0
Restriction:
  This class is not intended to be subclassed by clients.

### Field Summary

### Fields inherited from interface org.eclipse.jface.action.IAction

`AS_CHECK_BOX, AS_DROP_DOWN_MENU, AS_PUSH_BUTTON, AS_RADIO_BUTTON, AS_UNSPECIFIED, CHECKED, DESCRIPTION, ENABLED, HANDLED, IMAGE, RESULT, TEXT, TOOL_TIP_TEXT`

### Constructor Summary

Constructors
Constructor and Description
`AddUnimplementedConstructorsAction(org.eclipse.jdt.internal.ui.javaeditor.CompilationUnitEditor editor)` Note: This constructor is for internal use only.
`AddUnimplementedConstructorsAction(IWorkbenchSite site)` Creates a new `AddUnimplementedConstructorsAction`.

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`static IWorkspaceRunnable` `createRunnable(CompilationUnit astRoot, ITypeBinding type, IMethodBinding[] constructorsToOverride, int insertPos, boolean createComments, int visibility, boolean omitSuper)` Returns a runnable that creates the constructor stubs.
`void` `run(IStructuredSelection selection)` Executes this actions with the given structured selection.
`void` `run(ITextSelection selection)` Executes this actions with the given text selection.
`void` `selectionChanged(IStructuredSelection selection)` Notifies this action that the given structured selection has changed.
`void` `selectionChanged(ITextSelection selection)` Notifies this action that the given text selection has changed.

### Methods inherited from class org.eclipse.jdt.ui.actions.SelectionDispatchAction

`getSelection, getSelectionProvider, getShell, getSite, run, run, run, selectionChanged, selectionChanged, selectionChanged, setSpecialSelectionProvider, update`

### Methods inherited from class org.eclipse.jface.action.Action

`convertAccelerator, convertAccelerator, findKeyCode, findKeyString, findModifier, findModifierString, getAccelerator, getActionDefinitionId, getDescription, getDisabledImageDescriptor, getHelpListener, getHoverImageDescriptor, getId, getImageDescriptor, getMenuCreator, getStyle, getText, getToolTipText, isChecked, isEnabled, isHandled, notifyResult, removeAcceleratorText, removeMnemonics, runWithEvent, setAccelerator, setActionDefinitionId, setChecked, setDescription, setDisabledImageDescriptor, setEnabled, setHelpListener, setHoverImageDescriptor, setId, setImageDescriptor, setMenuCreator, setText, setToolTipText`

### Methods inherited from class org.eclipse.jface.action.AbstractAction

`addPropertyChangeListener, firePropertyChange, firePropertyChange, removePropertyChangeListener`

### Methods inherited from class org.eclipse.core.commands.common.EventManager

`addListenerObject, clearListeners, getListeners, isListenerAttached, removeListenerObject`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### AddUnimplementedConstructorsAction

    public AddUnimplementedConstructorsAction(org.eclipse.jdt.internal.ui.javaeditor.CompilationUnitEditor editor)

Note: This constructor is for internal use only. Clients should not call this constructor.

Parameters:
  `editor` - the compilation unit editor
Restriction:
  This constructor is not intended to be referenced by clients.

#### AddUnimplementedConstructorsAction

    public AddUnimplementedConstructorsAction(IWorkbenchSite site)

Creates a new `AddUnimplementedConstructorsAction`. The action requires that the selection provided by the site's selection provider is of type `org.eclipse.jface.viewers.IStructuredSelection`.

Parameters:
  `site` - the site providing context information for this action

### Method Detail

#### run

    public void run(IStructuredSelection selection)

Description copied from class: `SelectionDispatchAction`
Executes this actions with the given structured selection. This default implementation calls `run(ISelection selection)`.

Overrides:
  `run` in class `SelectionDispatchAction`
Parameters:
  `selection` - the selection

#### run

    public void run(ITextSelection selection)

Description copied from class: `SelectionDispatchAction`
Executes this actions with the given text selection. This default implementation calls `run(ISelection selection)`.

Overrides:
  `run` in class `SelectionDispatchAction`
Parameters:
  `selection` - the selection

#### createRunnable

    public static IWorkspaceRunnable createRunnable(CompilationUnit astRoot,
                                                    ITypeBinding type,
                                                    IMethodBinding[] constructorsToOverride,
                                                    int insertPos,
                                                    boolean createComments,
                                                    int visibility,
                                                    boolean omitSuper)

Returns a runnable that creates the constructor stubs.

Parameters:
  `astRoot` - the AST of the compilation unit to work on. The AST must have been created from a `ICompilationUnit`, that means `ASTParser.setSource(ICompilationUnit)` was used.
  `type` - the binding of the type to add the new methods to. The type binding must correspond to a type declaration in the AST.
  `constructorsToOverride` - the bindings of constructors to override or `null` to implement all visible constructors from the super class.
  `insertPos` - a hint for a location in the source where to insert the new methods or `-1` to use the default behavior.
  `createComments` - if set, comments will be added to the new methods.
  `visibility` - the visibility for the new modifiers. (see `Flags`) for visibility constants.
  `omitSuper` - if set, no `super()` call without arguments will be created.
Returns:
  returns a runnable that creates the constructor stubs.
Throws:
  `IllegalArgumentException` - a `IllegalArgumentException` is thrown if the AST passed has not been created from a `ICompilationUnit`.
Since:
  3.2

#### selectionChanged

    public void selectionChanged(IStructuredSelection selection)

Description copied from class: `SelectionDispatchAction`
Notifies this action that the given structured selection has changed. This default implementation calls `selectionChanged(ISelection selection)`.

Overrides:
  `selectionChanged` in class `SelectionDispatchAction`
Parameters:
  `selection` - the new selection

#### selectionChanged

    public void selectionChanged(ITextSelection selection)

Description copied from class: `SelectionDispatchAction`
Notifies this action that the given text selection has changed. This default implementation calls `selectionChanged(ISelection selection)`.

Overrides:
  `selectionChanged` in class `SelectionDispatchAction`
Parameters:
  `selection` - the new selection